import scene.*;
import scene.primitives.*;

/**
   The letter P defined using oriented Face primitives.
*/
public class P_faces extends Model
{
   /**
      The letter P defined using oriented Face primitives.
   */
   public P_faces()
   {
      super();

      Vertex[] v = new Vertex[24];

      int i = 0;
      v[i++] = new Vertex(0.00, 0.00,  0.0);  // front side
      v[i++] = new Vertex(0.00, 1.00,  0.0);
      v[i++] = new Vertex(0.75, 1.00,  0.0);
      v[i++] = new Vertex(1.00, 0.8,   0.0);
      v[i++] = new Vertex(1.00, 0.6,   0.0);
      v[i++] = new Vertex(0.75, 0.4,   0.0);
      v[i++] = new Vertex(0.25, 0.4,   0.0);
      v[i++] = new Vertex(0.25, 0.0,   0.0);

      v[i++] = new Vertex(0.25, 0.8,   0.0);   // i = 8
      v[i++] = new Vertex(0.75, 0.8,   0.0);
      v[i++] = new Vertex(0.75, 0.6,   0.0);
      v[i++] = new Vertex(0.25, 0.6,   0.0);


      v[i++] = new Vertex(0.00, 0.00, -0.25);  // back side (i = 12)
      v[i++] = new Vertex(0.00, 1.00, -0.25);
      v[i++] = new Vertex(0.75, 1.00, -0.25);
      v[i++] = new Vertex(1.00, 0.8,  -0.25);
      v[i++] = new Vertex(1.00, 0.6,  -0.25);
      v[i++] = new Vertex(0.75, 0.4,  -0.25);
      v[i++] = new Vertex(0.25, 0.4,  -0.25);
      v[i++] = new Vertex(0.25, 0.0,  -0.25);

      v[i++] = new Vertex(0.25, 0.8,  -0.25);  // i = 20
      v[i++] = new Vertex(0.75, 0.8,  -0.25);
      v[i++] = new Vertex(0.75, 0.6,  -0.25);
      v[i++] = new Vertex(0.25, 0.6,  -0.25);


      // around the outer faces
      addPrimitive( new Face(v[0], v[1], v[13], v[12]) );
      addPrimitive( new Face(v[13], v[1], v[2], v[14]) );
      addPrimitive( new Face(v[2], v[3], v[15], v[14]) );
      addPrimitive( new Face(v[3], v[4], v[16], v[15]) );
      addPrimitive( new Face(v[4], v[5], v[17], v[16]) );
      addPrimitive( new Face(v[5], v[6], v[18], v[17]) );
      addPrimitive( new Face(v[6], v[7], v[19], v[18]) );
      addPrimitive( new Face(v[7], v[0], v[12], v[19]) );

      // around the hole
      addPrimitive( new Face(v[20],  v[21],  v[9], v[8]) );
      addPrimitive( new Face(v[21],  v[22], v[10], v[9]) );
      addPrimitive( new Face(v[22], v[23], v[11], v[10]) );
      addPrimitive( new Face(v[23], v[20],  v[8], v[11]) );

      // front face
      addPrimitive( new Face( v[2],  v[1],  v[0],  v[7],  v[6],  v[5],  v[4],  v[3]) );
      addPrimitive( new Face( v[9],  v[8], v[11], v[10]) );

      // back face
      addPrimitive( new Face(v[12], v[13], v[14], v[15], v[16], v[17], v[18], v[19]) );
      addPrimitive( new Face(v[23], v[20], v[21], v[22]) );
   }
}
